////////////// $$$ Compil en Delphi 5 $$$ //////////////
///                  29 / 06 / 2002                   ///
///    exemple de Menu au style de Office XP          ///
///         fait par Amar Zamouche                   ///
///                                                   ///
///   Si vous avez des conseils, ides, remarques     ///
///        ou sugestions, contactez moi :             ///
///             zaa-amar@wissal.dz                    ///
///                                                   ///
/////////////////////////////////////////////////////////


unit XPMenu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ImgList, ExtCtrls, ToolWin, ComCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Quitter1: TMenuItem;
    N1: TMenuItem;
    Configurationdelimpression1: TMenuItem;
    Imprimer1: TMenuItem;
    N2: TMenuItem;
    Enregistrersous1: TMenuItem;
    Enregistrer1: TMenuItem;
    Ouvrir1: TMenuItem;
    Nouveau1: TMenuItem;
    Fentre1: TMenuItem;
    Supprimer: TMenuItem;
    N3: TMenuItem;
    Coller: TMenuItem;
    Couper: TMenuItem;
    copier: TMenuItem;
    modifier: TMenuItem;
    Aide1: TMenuItem;
    Apropos1: TMenuItem;
    Sommaire: TMenuItem;
    Index: TMenuItem;
    Label1: TLabel;
    ImageList1: TImageList;
    PopupMenu1: TPopupMenu;
    Procdures1: TMenuItem;
    Commandes1: TMenuItem;
    Listedindex1: TMenuItem;
    Index1: TMenuItem;
    Divers1: TMenuItem;
    Element11: TMenuItem;
    Element21: TMenuItem;
    Element31: TMenuItem;
    N4: TMenuItem;
    Element41: TMenuItem;
    Element51: TMenuItem;
    Element71: TMenuItem;
    N5: TMenuItem;
    Checked1: TMenuItem;
    Element12: TMenuItem;
    Element22: TMenuItem;
    Element32: TMenuItem;
    procedure Ouvrir1DrawItem(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; Selected: Boolean);
    procedure Enregistrer1DrawItem(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; Selected: Boolean);
    procedure Enregistrersous1DrawItem(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; Selected: Boolean);
    procedure N2DrawItem(Sender: TObject; ACanvas: TCanvas; ARect: TRect;
      Selected: Boolean);
    procedure Imprimer1DrawItem(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; Selected: Boolean);
    procedure Configurationdelimpression1DrawItem(Sender: TObject;
      ACanvas: TCanvas; ARect: TRect; Selected: Boolean);
    procedure N1DrawItem(Sender: TObject; ACanvas: TCanvas; ARect: TRect;
      Selected: Boolean);
    procedure Quitter1DrawItem(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; Selected: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure Nouveau1MeasureItem(Sender: TObject; ACanvas: TCanvas;
      var Width, Height: Integer);
    procedure modifierDrawItem(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; Selected: Boolean);
    procedure modifierMeasureItem(Sender: TObject; ACanvas: TCanvas;
      var Width, Height: Integer);
    procedure N2MeasureItem(Sender: TObject; ACanvas: TCanvas; var Width,
      Height: Integer);
    procedure N1MeasureItem(Sender: TObject; ACanvas: TCanvas; var Width,
      Height: Integer);
    procedure Quitter1Click(Sender: TObject);
    procedure Nouveau1DrawItem(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; Selected: Boolean);
    procedure Fichier1DrawItem(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; Selected: Boolean);
    procedure Fichier1MeasureItem(Sender: TObject; ACanvas: TCanvas;
      var Width, Height: Integer);
    procedure Apropos1Click(Sender: TObject);
    procedure Label1Click(Sender: TObject);
  private
    { Dclarations prives }
    procedure DrawMenuText(X: integer;ACanvas: TCanvas;ARect: TRect;Text: string);
  public
    { Dclarations publiques }

  end;

var
  Form1: TForm1;
  MyStyle : THandle;
  MRect, PRect, GRect : TRect;
  X, Y : integer;
implementation

uses ShellAPI;


procedure TForm1.DrawMenuText(X: integer;ACanvas: TCanvas;ARect: TRect;Text: string);
begin
 ARect.Left := X; 
 DrawText(ACanvas.Handle,
         PChar(Text),
         -1,
         ARect,
         DT_SINGLELINE or DT_LEFT or DT_VCENTER);
end;


{$R *.DFM}

procedure TForm1.Ouvrir1DrawItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
begin
IF  Selected  Then
  begin
   ACanvas.Brush.Color := $00D0B8B0;
   ACanvas.Pen.Style := PsSolid;
   MRect.Left := ARect.Left+1;
   MRect.Top := ARect.Top+1;
   MRect.Right := ARect.Right-1;
   MRect.Bottom := ARect.Bottom-1;
   ACanvas.FillRect(MRect);
  end
else
  begin
  ACanvas.Brush.Color := ClMenu;
  PRect.Left := ARect.Left;
  PRect.Top := ARect.Top;
  PRect.Right := ARect.Right;
  PRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(PRect);
  ACanvas.Brush.Color := $00F8F8F8;
  MRect.Left := ARect.Left+25;
  MRect.Top := ARect.Top;
  MRect.Right := ARect.Right;
  MRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(MRect);
  end;
end;

procedure TForm1.Enregistrer1DrawItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
begin
IF  Selected  Then
  begin
   ACanvas.Brush.Color := $00D0B8B0;
   ACanvas.Pen.Style := PsSolid;
   MRect.Left := ARect.Left+1;
   MRect.Top := ARect.Top+1;
   MRect.Right := ARect.Right-1;
   MRect.Bottom := ARect.Bottom-1;
   ACanvas.FillRect(MRect);
  end
else
  begin
  ACanvas.Brush.Color := ClMenu;
  PRect.Left := ARect.Left;
  PRect.Top := ARect.Top;
  PRect.Right := ARect.Right;
  PRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(PRect);
  ACanvas.Brush.Color := $00F8F8F8;
  MRect.Left := ARect.Left+25;
  MRect.Top := ARect.Top;
  MRect.Right := ARect.Right;
  MRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(MRect);
  end;

end;

procedure TForm1.Enregistrersous1DrawItem(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect; Selected: Boolean);
begin
IF  Selected  Then
  begin
   ACanvas.Brush.Color := $00D0B8B0;
   ACanvas.Pen.Style := PsSolid;
   MRect.Left := ARect.Left+1;
   MRect.Top := ARect.Top+1;
   MRect.Right := ARect.Right-1;
   MRect.Bottom := ARect.Bottom-1;
   ACanvas.FillRect(MRect);
  end
else
  begin
  ACanvas.Brush.Color := ClMenu;
  PRect.Left := ARect.Left;
  PRect.Top := ARect.Top;
  PRect.Right := ARect.Right;
  PRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(PRect);
  ACanvas.Brush.Color := $00F8F8F8;
  MRect.Left := ARect.Left+25;
  MRect.Top := ARect.Top;
  MRect.Right := ARect.Right;
  MRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(MRect);
  end;
end;

procedure TForm1.N2DrawItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
begin
  ACanvas.Brush.Color := ClInActiveCaptionText;
  MRect.Left := ARect.Left+25;
  MRect.Top := ARect.Top;
  MRect.Right := ARect.Right;
  MRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(MRect);
end;

procedure TForm1.Imprimer1DrawItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
begin
IF  Selected  Then
  begin
   ACanvas.Brush.Color := $00D0B8B0;
   ACanvas.Pen.Style := PsSolid;
   MRect.Left := ARect.Left+1;
   MRect.Top := ARect.Top+1;
   MRect.Right := ARect.Right-1;
   MRect.Bottom := ARect.Bottom-1;
   ACanvas.FillRect(MRect);
  end
else
  begin
  ACanvas.Brush.Color := ClMenu;
  PRect.Left := ARect.Left;
  PRect.Top := ARect.Top;
  PRect.Right := ARect.Right;
  PRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(PRect);
  ACanvas.Brush.Color := $00F8F8F8;
  MRect.Left := ARect.Left+25;
  MRect.Top := ARect.Top;
  MRect.Right := ARect.Right;
  MRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(MRect);
  end;
end;

procedure TForm1.Configurationdelimpression1DrawItem(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect; Selected: Boolean);
begin
IF  Selected  Then
  begin
   ACanvas.Brush.Color := $00D0B8B0;
   ACanvas.Pen.Style := PsSolid;
   MRect.Left := ARect.Left+1;
   MRect.Top := ARect.Top+1;
   MRect.Right := ARect.Right-1;
   MRect.Bottom := ARect.Bottom-1;
   ACanvas.FillRect(MRect);
  end
else
  begin
  ACanvas.Brush.Color := ClMenu;
  PRect.Left := ARect.Left;
  PRect.Top := ARect.Top;
  PRect.Right := ARect.Right;
  PRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(PRect);
  ACanvas.Brush.Color := $00F8F8F8;
  MRect.Left := ARect.Left+25;
  MRect.Top := ARect.Top;
  MRect.Right := ARect.Right;
  MRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(MRect);
  end;
end;

procedure TForm1.N1DrawItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
begin
  ACanvas.Brush.Color := $00F8F8F8;
  MRect.Left := ARect.Left+25;
  MRect.Top := ARect.Top;
  MRect.Right := ARect.Right;
  MRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(MRect);
end;

procedure TForm1.Quitter1DrawItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
begin
IF  Selected  Then
  begin
   ACanvas.Brush.Color := $00D0B8B0;
   ACanvas.Pen.Style := PsSolid;
   MRect.Left := ARect.Left+1;
   MRect.Top := ARect.Top+1;
   MRect.Right := ARect.Right-1;
   MRect.Bottom := ARect.Bottom-1;
   ACanvas.FillRect(MRect);
  end
else
  begin
  ACanvas.Brush.Color := ClMenu;
  PRect.Left := ARect.Left;
  PRect.Top := ARect.Top;
  PRect.Right := ARect.Right;
  PRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(PRect);
  ACanvas.Brush.Color := $00F8F8F8;
  MRect.Left := ARect.Left+25;
  MRect.Top := ARect.Top;
  MRect.Right := ARect.Right;
  MRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(MRect);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 p : TRect;
begin
 Form1.Canvas.pen.Color := ClRed;
 Form1.Canvas.pen.width := 1;
 P.Left := 10;
 P.Top := 30;
 Form1.Canvas.Rectangle(P);
end;

procedure TForm1.Nouveau1MeasureItem(Sender: TObject; ACanvas: TCanvas;
  var Width, Height: Integer);
begin
 Height := 22;
 Width := Width + 30;
end;

procedure TForm1.modifierDrawItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
begin
IF  Selected  Then
  begin
   ACanvas.Brush.Color := $00D0B8B0;
   MRect.Left := ARect.Left+1;
   MRect.Top := ARect.Top+1;
   MRect.Right := ARect.Right-1;
   MRect.Bottom := ARect.Bottom-1;
   ACanvas.FillRect(MRect);
   ACanvas.Brush.Color := $00682400;
   ACanvas.FrameRect(MRect);
  end
else
  begin
  ACanvas.Brush.Color := ClMenu;
  PRect.Left := ARect.Left;
  PRect.Top := ARect.Top;
  PRect.Right := ARect.Right;
  PRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(PRect);
  ACanvas.Brush.Color := $00F8F8F8;
  MRect.Left := ARect.Left+25;
  MRect.Top := ARect.Top;
  MRect.Right := ARect.Right;
  MRect.Bottom := ARect.Bottom;
  ACanvas.FillRect(MRect);
  end;

end;

procedure TForm1.modifierMeasureItem(Sender: TObject; ACanvas: TCanvas;
  var Width, Height: Integer);
begin
Height := 22;
end;

procedure TForm1.N2MeasureItem(Sender: TObject; ACanvas: TCanvas;
  var Width, Height: Integer);
begin
 height := 2;
end;

procedure TForm1.N1MeasureItem(Sender: TObject; ACanvas: TCanvas;
  var Width, Height: Integer);
begin
 Height := 2;
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.Nouveau1DrawItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
begin
//------------- { dterminer la couleur et la font de la item slctionne }-------------//

IF  Selected  Then
  begin
   { changer la couleur du canevas on lui attribuer la couleur de
     slction du style XP }
   ACanvas.Brush.Color := $00C2A398;
   { crer le rectangle qui sera afficher }
   MRect.Left := Arect.Left+28;
   MRect.Top := ARect.Top+1;
   MRect.Right := ARect.Right-1;
   MRect.Bottom := ARect.Bottom-1;
   { redssiner la Item }
   ACanvas.FillRect(MRect);

   { crer la bordure du rctangle slctionn }
   ACanvas.Brush.Color := $00682400;

//------------------{ affichage du text }-----------------//

   { passer en mode affichage trensparent }
   setBkMode(ACanvas.Handle, Transparent);
   { dfinition de la font }
   ACanvas.Font.Color := ClRed;

   { affichage du text }
   DrawMenuText(30, ACanvas, ARect, (sender as TMenuItem).Caption);

   { crer la Frame qui presente la bordure de la slction }
   ACanvas.FrameRect(MRect);

  end

else

//---------------- { dterminer la couleur et la font de la item } -----------//
  begin

//---------------------------{ rctangle du glyph }---------------------//


 // 1)- rctangle principal ou sera affich le text (Captions) des (items)

 ACanvas.Brush.Color := $00D6DCE2;

 ACanvas.FillRect(ARect);


   if ((Sender as TMenuItem).ImageIndex > - 1) and not (sender as TMenuItem).Checked then

          begin

             { rctangle qui est comme tant l'arrire plan du text Caption }

                ACanvas.Brush.Color := $00E9ECEF;

                GRect.Left := ARect.Left + 27;
                GRect.Top := ARect.Top;
                GRect.Right := ARect.Right;
                GRect.Bottom := ARect.Bottom;

                ACanvas.FillRect(GRect);



              // 2)- rctangle arire plan du glyph

                ACanvas.Brush.Color := $00D0B8B0;
                MRect.Left := ARect.Left + 1;
                MRect.Top := ARect.Top + 1;
                MRect.Right := MRect.Left + 25;
                MRect.Bottom := ARect.Bottom - 1;

                ACanvas.FillRect(MRect);


  // 3)-  Framerctangle qui est comme tant la bordure de l'arire plan du glyph
  //      et aussi pour l'affichage des captions

               ACanvas.Brush.Color := $00682400;

               ACanvas.FrameRect(MRect);

               SetBKMode(ACanvas.Handle, Transparent);

               ImageList1.Draw(ACanvas, MRect.Left + 3, MRect.Top + 2, (Sender as TMenuItem).ImageIndex);

               ACanvas.Font.Color := ClBlue;
               DrawMenuText(30, ACanvas, GRect, (Sender as TMenuItem).Caption);


          end

   else
          Begin

        { Rctangle qui reprsente le canevas du menu ( arrire plan }

                ACanvas.Brush.Color := $00D6DCE2;
                PRect.Left := ARect.Left + 1;
                PRect.Top := ARect.Top + 1;
                PRect.Right := PRect.Left + 25;
                PRect.Bottom := ARect.Bottom - 1;

                ACanvas.FillRect(PRect);


             { rctangle qui est comme tant l'arrire du text Caption }

                ACanvas.Brush.Color := $00E9ECEF;

                GRect.Left := ARect.Left + 27;
                GRect.Top := ARect.Top;
                GRect.Right := ARect.Right;
                GRect.Bottom := ARect.Bottom;

                ACanvas.FillRect(GRect);


                SetBKMode(ACanvas.Handle, Transparent);

                ACanvas.Font.Color := ClBlue;
      if not (Sender as TMenuItem).checked then
                DrawMenuText(30, ACanvas, GRect, (Sender as TMenuItem).Caption)
      else
       begin
                ACanvas.Brush.Color := $00D0B8B0;
                MRect.Left := ARect.Left + 1;
                MRect.Top := ARect.Top + 1;
                MRect.Right := MRect.Left + 25;
                MRect.Bottom := ARect.Bottom - 1;

                ACanvas.FillRect(MRect);

                ACanvas.Brush.Color := $00682400;

                ACanvas.FrameRect(MRect);

                SetBKMode(ACanvas.Handle, Transparent);

                { dessin du radioButton }

                 begin
                  // 1)---------
                   ACanvas.Pen.Color := ClWhite;
                   ACanvas.MoveTo(MRect.Left + 3, MRect.Top + 5);
                   ACanvas.LineTo(MRect.Left + 5, MRect.Bottom - 3);

                  // 2)---------

                   ACanvas.MoveTo(MRect.Left + 3, MRect.Top + 5);
                   ACanvas.LineTo(MRect.Left + 7, MRect.Bottom - 3);

                  // 3)---------

                   ACanvas.MoveTo(MRect.Left + 4, MRect.Bottom - 3);
                   ACanvas.LineTo(MRect.Right -3, MRect.Top+2);

                  // 4)---------

                   ACanvas.MoveTo(MRect.Left + 6, MRect.Bottom - 3);
                   ACanvas.LineTo(MRect.Right -3, MRect.Top +2);

                  // 5)---------


                 end;
                DrawMenuText(30, ACanvas, GRect, (Sender as TMenuItem).Caption)

       end;


          end;
//=-=-=--=-=--=-=-=-=--=-=--=-=-=-=-=-=-=--=-=-=-=--=-=-=-=-=-=-=--=-=-=-=-=-=//



  end;
end;

procedure TForm1.Fichier1DrawItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
begin
//------------- { dterminer la couleur et la font de la item slctionne }-------------//
IF  Selected  Then
  begin
   { changer la couleur du canevas on lui attribuer la couleur de
     slction du style XP }
   ACanvas.Brush.Color := $00C2A398;
   { crer le rectangle qui sera afficher }
   MRect.Left := ARect.Left+1;
   MRect.Top := ARect.Top+1;
   MRect.Right := ARect.Right-1;
   MRect.Bottom := ARect.Bottom-1;
   { redssiner la Item }
   ACanvas.FillRect(MRect);

   { crer la bordure du rctangle slctionn }
   ACanvas.Brush.Color := $00682400;

//------------------{ affichage du text }-----------------//

   { passer en mode affichage trensparent }
   setBkMode(ACanvas.Handle, Transparent);
   { dfinition de la font }
   ACanvas.Font.Color := ClRed;

   { affichage du text }
   DrawMenuText(MRect.Left + 3, ACanvas, MRect, (sender as TMenuItem).Caption);

   { crer la Frame qui presente la bordure de la slction }
   ACanvas.FrameRect(MRect);

  end

else

//---------------- { dterminer la couleur et la font de la item } -----------//
  begin


//---------------------------{ rctangle du glyph }---------------------//

 // 1)- rctangle principal ou sera affich le text (Captions) des (items)

 ACanvas.Brush.Color := ClMenu;

   MRect.Left := ARect.Left+1;
   MRect.Top := ARect.Top+1;
   MRect.Right := ARect.Right-1;
   MRect.Bottom := ARect.Bottom-1;
   { redssiner la Item }
   ACanvas.FillRect(MRect);

//------------------{ affichage du text }-----------------//

   { passer en mode affichage trensparent }
   setBkMode(ACanvas.Handle, Transparent);
   { dfinition de la font }
   ACanvas.Font.Color := ClBlue;

   { affichage du text }
   DrawMenuText(MRect.Left + 3, ACanvas, MRect, (sender as TMenuItem).Caption);



  end;



//=-=-=--=-=--=-=-=-=--=-=--=-=-=-=-=-=-=--=-=-=-=--=-=-=-=-=-=-=--=-=-=-=-=-=//



end;


procedure TForm1.Fichier1MeasureItem(Sender: TObject; ACanvas: TCanvas;
  var Width, Height: Integer);
begin
 width := width + 25;
end;

procedure TForm1.Apropos1Click(Sender: TObject);
begin
 MessageBox(Handle, Pchar('Exemple Fait par Amar Zamouche '+#13+'zaa-amar@wissal.dz'), Pchar('A propos :'), MB_ICONINFORMATION);
end;

procedure TForm1.Label1Click(Sender: TObject);
begin
ShellExecute(0, 'OPEN', 'mailto:zaa-amar@wissal.dz',nil,nil,SW_SHOWNORMAL);
end;

end.
